Slope Trick
Author: Benjamin Qi
Slope trick refers to a way to manipulate piecewise linear convex functions. Includes a simple solution to USACO Landscaping.
Tutorials
Resources | ||||
---|---|---|---|---|
CF | 3 problems using this trick | |||
CF | clarifying the above and another example problem |
From the latter link (modified):
Slope trick is a way to represent a function that satisfies the following conditions:
It can be divided into multiple sections, where each section is a linear function (usually) with an integer slope. It is a convex/concave function. In other words, the slope of each section is non-decreasing or non-increasing when scanning the function from left to right.
It's generally applicable as a DP optimization.
Pro Tip
Usually you can come up with a slower (usually ) DP first and then optimize it to with slope trick.
The rest of this module assumes that you know the basic idea of this trick. In particular, you should be able to solve the following problem (it's almost identical to the first problem in zscoder's tutorial):
Status | Source | Problem Name | Difficulty | Tags | |
---|---|---|---|---|---|
CSES | Easy | Show TagsSlope Trick |
It's ok if you found the explanations confusing; the example below should help clarify.
Buy Low Sell High
Focus Problem – try your best to solve this problem before continuing!
Slow Solution
Let denote the maximum amount of money you can have on day if you have exactly shares of stock on that day. The final answer will be . This solution runs in time.
vector<vl> dp = {{0}};int N;int main() {re(N);F0R(i, N) {int x;re(x);dp.pb(vl(i + 2, -INF));F0R(j, i + 1) {
If we run this on the first sample case, then we get the following table:
Input: 9 10 5 4 7 9 12 6 2 10 Output: dp[0] = { 0} dp[1] = { 0, -10} dp[2] = { 0, -5, -15} dp[3] = { 0, -4, -9, -19} dp[4] = { 3, -2, -9, -16, -26} dp[5] = { 7, 0, -7, -16, -25, -35} dp[6] = { 12, 5, -4, -13, -23, -35, -47} dp[7] = { 12, 6, -1, -10, -19, -29, -41, -53} dp[8] = { 12, 10, 4, -3, -12, -21, -31, -43, -55} dp[9] = { 20, 14, 7, -2, -11, -21, -31, -41, -53, -65}
However, the DP values look quite special! Specifically, let
Then for all . In other words, as a function of is concave down.
Full Solution
We'll process the shares in order. Suppose that we are currently considering the -th day, where shares are worth . We can replace (buy or sell a share) in the statement with (buy, then sell somewhere between 0 and 2 shares).
If we currently have shares and overall balance , then after buying, increases by one and decreases by . So we set for all . Note that the differences between every two consecutive elements of have not changed.
If we choose to sell a share, this is equivalent to setting for all at the same time. By the concavity condition, will hold for all less than a certain threshold while will remain unchanged for all others. So this is equivalent to inserting into the list of differences while maintaining the condition that the differences are in sorted order.
So choosing to sell between 0 and 2 shares is represented by adding to the list of differences two times. After that, we should pop the smallest difference in the list because we can't end up with a negative amount of shares.
Example
The implementation is quite simple; maintain a priority queue representing that allows you to pop the minimum element. After adding elements, stores the current value of . At the end, you add all the differences in to go from to .
#include <bits/stdc++.h>using namespace std;int main() {int N;cin >> N;priority_queue<int, vector<int>, greater<int>> pq;long long ans = 0;for (int i = 0; i < N; ++i) {int p;
Extension
Stock Trading (USACO Camp): What if your amount of shares can go negative, but you can never have more than shares or less than ?
Potatoes & Fertilizers
Focus Problem – try your best to solve this problem before continuing!
Simplifying the Problem
Instead of saying that moving fertilizer from segment to segment costs , we'll say that it costs to move fertilizer from a segment to an adjacent segment.
Let the values of after all the transfers be . If we know this final sequence, how much did the transfers cost (in the best case scenario)? It turns out that this is just
We can show that this is a lower bound and that it's attainable. The term denotes the number of units of fertilizer that move from segment to segment . Namely, if is positive then units of fertilizer moved from segment to segment ; otherwise, units of fertilizer moved in the opposite direction. Note that it is never optimal to have fertilizer moving in both directions.
Let and define for each . Similarly, define and . Since we want for all , we should have Conversely, every sequence that satisfies this property corresponds to a valid way to assign values of .
Now you can verify that . This makes sense since moving one unit of fertilizer one position is equivalent to changing one of the by one (although always remain the same).
Slow Solution
For each and , let be the minimum cost to determine such that . Note that by definition, . We can easily calculate these values in time.
Full Solution
Similar to before, this DP is concave up for a fixed ! Given a piecewise linear function that takes as input and outputs , we need to support the following two operations to transform this function into .
- Add to the function for some
- Set for all
Again, these can be done with a priority queue. Instead of storing the consecutive differences, we store the points where the slope of the piecewise linear function changes by one.
- The first operation corresponds to inserting into the priority queue two times because the slope increases by two at .
- The latter operation just corresponds to removing the greatest element of the priority queue.
This solution runs in time.
#include <bits/stdc++.h>using namespace std;typedef long long ll;int N;ll fst = 0; // value of DP function at 0priority_queue<ll> points; // points where DP function changes slopeint main() {
USACO Landscaping
Focus Problem – try your best to solve this problem before continuing!
This looks similar to the previous task (we're moving dirt instead of fertilizer), so it's not too hard to guess that slope trick is applicable.
Slow Solution
Let equal the number of ways to move dirt around the first flowerbeds such that the first flowerbeds all have the correct amount of dirt while the -th flowerbed has extra units of dirt (or lacks units of dirt if is negative). The answer will be .
Full Solution
This DP is concave up for any fixed . To get from we must be able to support the following operations.
- Shift the DP curve units to the right.
- Shift the DP curve units to the left.
- Add to for all .
- Set and for all .
As before, it helps to look at the differences instead. We'll maintain separate deques for depending on whether or . We'll call these the left and right deques, respectively.
- The first two operations correspond to repeatedly popping the last element off of the left deque and adding it to the front of the right deque (or vice versa, depending on the direction of the shift).
- The third operation corresponds to subtracting from all elements of the left deque and adding to all elements of the right deque.
- The last operation corresponds to setting for all and for all .
We can implement the last operation by updating all of the differences in the deques "lazily." This solution runs in time.
#include <bits/stdc++.h>using namespace std;int N, X, Y, Z;int difl, difr; // "lazy" updatedeque<int> L, R;long long ans;void rig() { // shift right A, so origin moves left
Extension
We can solve this problem when is not so small by
maintaining a map from to for all such that the latter
quantity is nonzero. Then the operation "add to for all
" corresponds to a point update in the map (advance()
in the code below).
Code from Alex Wei.
#include <bits/stdc++.h>using namespace std;typedef long long ll;const ll INF = 1LL << 60;ifstream fin("landscape.in");ofstream fout("landscape.out");
Problems
Although we haven't provided any examples of this, some of the problems below will require you to merge two slope containers (usually priority queues).
Status | Source | Problem Name | Difficulty | Tags | |
---|---|---|---|---|---|
CF | Normal | Show TagsSlope Trick | |||
CC | Normal | Show TagsSlope Trick | |||
CEOI | Normal | Show TagsSlope Trick | |||
NOI.sg | Hard | Show TagsSlope Trick | |||
CF | Hard | Show TagsSlope Trick | |||
CF | Hard | Show TagsSlope Trick | |||
APIO | Hard | Show TagsSlope Trick, Small to Large | |||
CF | Very Hard | Show TagsSlope Trick | |||
ICPC WF | Very Hard | Show TagsSlope Trick, Small to Large |
Module Progress:
Join the USACO Forum!
Stuck on a problem, or don't understand a module? Join the USACO Forum and get help from other competitive programmers!